image: node

stages:
  - build
  - test
  - deploy review
  - deploy staging
  - deploy production
  - production test
  - cache

cache:
  key: ${CI_COMMIT_REF_SLUG}
  policy: pull
  paths:
    - node_modules/

variables:
  STAGING_DOMAIN: dvs-c-007-staging.surge.sh
  PRODUCTION_DOMAIN: dvs-c-007.surge.sh

update cache:
  stage: cache
  only:
    - schedules
  script:
    - npm install
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    policy: push
    paths:
      - node_modules/

build website:
  stage: build
  except:
    - schedules
  script:
    - echo $CI_COMMIT_SHORT_SHA
    - npm install
    - npm instal -g gatsby-cli
    - gatsby build
    - sed -i "s/%%VERSION%%/$CI_COMMIT_SHORT_SHA/" ./public/index.html
  artifacts:
    paths:
      - ./public

test artifact:
  image: alpine
  cache: {}
  stage: test
  except:
    - schedules
  script:
    - grep -q "Gatsby" ./public/index.html

test website:
  stage: test
  except:
    - schedules
  script:
    - npm install
    - npm install -g gatsby-cli
    - gatsby serve &
    - sleep 6
    - curl "http://localhost:9000" | tac | tac | grep -q "Gatsby"

deploy review:
  stage: deploy review
  only:
    - merge_requests
  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: http://dvs-c-007-$CI_ENVIRONMENT_SLUG.surge.sh
    on_stop: stop review
  script:
    - npm install --global surge
    - surge --project ./public --domain dvs-c-007-$CI_ENVIRONMENT_SLUG.surge.sh

stop review:
  stage: deploy review
  only:
    - merge_requests
  variables:
    GIT_STRATEGY: none
  script:
    - npm install --global surge
    - surge teardown dvs-c-007-$CI_ENVIRONMENT_SLUG.surge.sh
  when: manual
  environment:
    name: review/$CI_COMMIT_REF_NAME
    action: stop

deploy staging:
  stage: deploy staging
  except:
    - schedules
  environment:
    name: staging
    url: http://$STAGING_DOMAIN
  only:
    - master
  script:
    - npm install --global surge
    - surge --project ./public --domain $STAGING_DOMAIN

deploy production:
  stage: deploy production
  except:
    - schedules
  environment:
    name: production
    url: http://$PRODUCTION_DOMAIN
  only:
    - master
  #when: manual
  #allow_failure: false
  script:
    - npm install --global surge
    - surge --project ./public --domain $PRODUCTION_DOMAIN

production deployment:
  image: alpine
  cache: {}
  stage: production test
  except:
    - schedules
  only:
    - master
  script:
    - apk --no-cache add curl
    - curl -s "http://dvs-c-007.surge.sh/" | grep -q "Hi people"
    - curl -s "http://dvs-c-007.surge.sh/" | grep -q "$CI_COMMIT_SHORT_SHA"
